#!/usr/bin/perl

@dirs=qw( autostart ContextNotify ContextNotifyClient ContextCommon
starter ContextClient BlackBoard BlackBoardClient ContextSensors ContextNetwork
BlackBoardServer ContextCommon2 ContextMedia ContextSensors ContextUI ContextMedia
Recognizer ContextServer ContextMediaApp Context_log ContextContacts 
ContextCallLog );

$hs{"context_uids.h"}=1;
$hs{"context_uids.rh"}=1;

$|=1;
print "processing directories for includes";
foreach $dir (@dirs) {
	print ".";
	unless (chdir("$dir/inc")) {
		print STDERR "cannot chdir to $dir/inc";
		next;
	}
	foreach my $h (<*.h *.H>) {
		$hs{$h}=1;
	}
	chdir("../..");
}
print "\n";

print "processing directories for code\n";
#@dirs=qw(starter);
foreach $dir (@dirs) {
	foreach my $subdir (qw(src inc)) {
		print "  $dir/$subdir";
		unless (chdir("$dir/$subdir")) {
			print STDERR "cannot chdir to $dir/$subdir";
			next;
		}
		my @files=();
		if ($subdir eq "src") { @files=<*.cpp>; }
		else { @files=<*.h *.H>; }
		foreach my $cpp (@files) {
			print ".";
			unless (open(IN, "<$cpp")) {
				print STDERR "cannot open $dir/$subdir/$cpp for reading";
				next;
			}
			unless (open(OUT, ">${cpp}.bak")) {
				close(IN);
				print STDERR "cannot open $dir/$subdir/${cpp}.bar for writing";
				next;
			}
			while(<IN>) {
				if (/^\s*#include\s+<([^>]+)>\s+$/) {
					$f=$1;
					if ($hs{$f}) {
						print OUT '#include "', $f, '"', "\n";
						next;
					}
				}
				print OUT $_;
			}
			close(IN); close(OUT);
			system("cp ${cpp}.bak $cpp");
		}
		print "\n";
		chdir("../..");
	}
}
