#!/usr/bin/perl

use XML::Parser;
use Time::Local;

$ENV{'PATH'}="/bin:/usr/bin";
use CGI;
use CGI::Carp;
use Fcntl ':flock'; # import LOCK_* constants

sub get_fields {
	my $content=shift;
	unless ( substr($content, 0, 5) eq "<?xml" ) {
		$content="<?xml version='1.0' encoding='iso-8859-1'?>" . $content;
	}
	my $xp = new XML::Parser(Handlers => { 
		Char => \&char_handler ,
		Start => \&start_handler,
		End => \&end_handler,
	});

	eval { $xp->parse($content, ProtocolEncoding => 'ISO-8859-1') };
	if ($@) { $desc .=  " error: " . $@; }
	$desc=~s/\r//g;
	$desc=~s/\n//g;
	my %fields=(
		tag	=>	$tag,
		desc	=>	$desc,
		prev	=>	$prev,
		visualcode	=>	$vc,
		current	=>	$current);
	return \%fields;
}


sub char_handler {
  my($xp, $data) = @_;
  if ($in_tag) { $tag .= $data; }
  elsif ($in_desc) { $desc .= $data; }
  elsif ($in_prev) { $prev .= $data; }
  elsif ($in_current) { $current .= $data; }
  elsif ($in_vc) { $vc .= $data; }
}
sub start_handler {
  my($xp, $data, @rest) = @_;
  $in_tag=1 if ($data =~ /tag/);
  $in_desc=1 if ($data =~ /desc/);
  $in_prev=1 if ($data =~ /^base.previous$/);
  $in_current=1 if ($data =~ /^base.current$/);
  $in_vc=1 if ($data =~ /^threadid$/);
}
sub end_handler {
  my($xp, $data) = @_;
  $in_tag=$in_desc=$in_prev=$in_current=$in_vc=0;
}



sub response
{
	(my $status, my $msg)=@_;
	print "Content-Type: text/plain\n";
	#print "Status: $status\n";
	print "\n";
	print $msg;
	print "\n";
	exit 0;
}


my $cgi=new CGI;
my $DIR="/home/mraento/public_html/vc/";

my $filen=$cgi->param('photo');
if ($filen) {
	my $meta=$cgi->param('packet');
	my $packet_data;
	while(<$meta>) {
		$packet_data .= $_;
	}
	my $f=get_fields($packet_data);
	my $thread=$f->{'visualcode'};
	if (!$thread) { $thread=1; }

	open(IN, "+<$DIR/num.txt") || &response(201, "cannot open index file");
	flock(IN,LOCK_EX)  || &response(201, "cannot lock index file");
	seek(IN, 0, 0) || &response(201, "cannot seek in index");
	
	my $num=0;
	while(<IN>) {
		chop;
		$num=$_;
	}
	$num++;
	seek(IN, 0, 0) || &response(201, "cannot seek in index");
	print IN $num, "\n";
	flock(IN,LOCK_UN);
	close(IN);

	my $ext=$filen;
	$ext=~s/^.*\.([a-z0-9]+)$/.$1/;
	$store_filen=$DIR . $thread . "/" . $num . $ext;

	my $path=$store_filen;
	$path=~s/\/[^\/]+$/\//;
	mkdir($path);
	system("chmod 0755 $path");

	open(OUT, ">" . $store_filen) || &response(201, "Error: Cannot open output file $store_filen");
	while (<$filen>) {
		print OUT $_;
	}
	close(OUT);
	system("chmod 0644 $store_filen");
	if ($store_filen=~/jpg$/i) {
		my $full_filen=$store_filen;
		$full_filen=~s/\.jpg$/_full.jpg/i;
		system("mv $store_filen $full_filen");
		system("jpegtopnm $full_filen | pnmscale -xsize 172 | pnmtojpeg -quality 90 > $store_filen");
		system("chmod 0644 $store_filen");
	}
	if ($meta) {
		$store_filen=~s/\.[^.]*$//g;
		$store_filen .= ".xml";
		open(OUT2, ">" . $store_filen) || &response(201, "Error: Cannot open output file $store_filen");
		print OUT2 $packet_data;
		close(OUT2);
		system("chmod 0644 $store_filen");
	}

	&response(200, "OK");
} else {
	&response(201, "Error: no file given");
}
