#!/usr/bin/perl

#use strict;


# bleh, this script is one big hack
# we really should figure out a way to use real
# makefiles for the whole process
#
# this script is necessary to keep the build time acceptable
#
# - MR
#

sub usage() {
	print "Usage:\n\n";
	print "run_abld_for_bldinf.pl PLATFORM RELEASE\n";
	exit 1;
}

if ($#ARGV != 1) {
	usage();
}

open(BLDINF, "<bld.inf") || die "cannot open bld.inf";
my $release=$ARGV[$#ARGV];
my $platform=$ARGV[$#ARGV-1];

use Cwd;

my %mmps;
open(BLDINF, "<bld.inf") || die "cannot open bld.inf";
while(<BLDINF>) {
	next if (m!^//!);
	next unless (/mmp$/i);
	
	chop; s/
//;
	my $mmp=$_;

	/^(.*)\\([^\\]*).mmp$/i;
	my ($path, $file)=($1, $2);
	$mmps{$file}=$path;
}
close(BLDINF);

sub mmp($) {
	my $proj=shift;
	return $mmps{$proj} . "\\" . $proj . ".mmp";
}

my $fhnum=0;

sub make_sure_deffile_exists($) {
	my $def=defname(shift);
	print "DEFFILE: $def\n";
	unless ( -f $def ) { 
		open(DEF, ">$def") || die "cannot open $def";
		print DEF "EXPORTS\n";
		close(DEF);
	}
}

sub getdepends($$$$) {
	# returns \@files, $type, $has_resource, \@sourcefiles, $sourcedir, \@includedirs,
	#	$in_bitmap, $deffile
	my $file=shift;
	my $dir=shift;
	my $sourcedir=shift;
	my @sourcefiles=();
	my @includedirs=();
	my $in_bitmap=shift;
	$dir=~s/\\[^\\]+$/\\/;
	my $in="fh" . $fhnum++;
	open($in, "<$file") || die "cannot open $file";
	my @ret; my $type; my $has_resource;
	push(@ret, $file);
	while(<$in>) {
		s!//.*!!;
		if ( ! $in_bitmap ) {
			if (/targettype\s*(.*)/i) {
				$type=uc($1);
				next;
			}
			if (/^\s*SYSTEMRESOURCE/i || /^\s*RESOURCE/i) {
				$has_resource=1;
				next;
			}
			if (/^\s*SOURCEPATH\s+(.*)\r?/) {
				$sourcedir=$dir . $1;
				$sourcedir .= "\\" unless ( $sourcedir =~ /.*\\$/ );
				next;
			}
			if (/^\s*SOURCE\s+(.*)\r?/) {
				my @s=split(/\s+/, $1);
				foreach my $s (@s) {
					push(@sourcefiles, $sourcedir . $s);
				}
				next;
			}
			if (/^\s*(SYSTEM|USER)INCLUDE\s+(.*)\r?/) {
				#print $_;
				my @s=split(/\s+/, $2);
				foreach my $s (@s) {
					#print "inc $dir$s\n";
					push(@includedirs, $dir . $s);
				}
				next;
			}
		}  else {
			if (/^\s* END/) { $in_bitmap=0; next; }
		}
		if (/^\s*START\s*BITMAP/i) {
			$in_bitmap=1;
			next;
		}
		next unless /#include/;
		/#include\s*[<"]\s*(.*)\s*[>"]/;
		my ($low_files, $low_type, $low_res, $low_sourcefiles, $low_sourcedir,
			$low_includedirs, $low_in_bitmap) 
			= getdepends($dir . $1, $file, $sourcedir, $in_bitmap);
		if ( defined($low_type) ) { $type=$low_type; }
		if ($low_res) { $has_resource=1; }
		$sourcedir=$low_sourcedir;
		$in_bitmap=$low_in_bitmap;
		push @ret, @{$low_files};
		push @sourcefiles, @{$low_sourcefiles};
		push @includedirs, @{$low_includedirs};
	}
	close($in);
	return (\@ret, $type, $has_resource, \@sourcefiles, $sourcedir, \@includedirs,
		$in_bitmap);
}


sub makefilename($) {

	my $proj=shift;
	my $makefile=$ENV{'EPOCROOT'};
	$makefile.="epoc32\\BUILD";
	my $d=cwd;
	$d=~s/[a-z]://i;
	$d=~s!/!\\!g;
	$makefile.=$d;
	$makefile.="\\";
	my $mmp=mmp($proj);
	$mmp=~s/\\[^\\]+$/\\/;
	$makefile .= $mmp . $proj . "\\" . $platform . "\\" . $proj . "." . $platform;

	return $makefile;
}

sub defname($) {

	my $mmp=mmp(shift);
	$mmp =~ s/\.mmp//;
	$mmp .= "-" . $platform . "u.def";

	return $mmp;
}

sub haschanged($$) {
	my $proj=shift;
	my $depends=shift;

	my $makefile=makefilename($proj);
	#print "MAKEFILE $makefile \n";
	my @depends=@{$depends};
	my @s=stat($makefile);
	my $mftime=$s[9];
	foreach my $d (@depends) {
		@s=stat($d);
		return 1 if ( $s[9] > $mftime);
	}
	return 0;
}

my %incdepends=();

sub incdepends($$) {
	my $file=shift;
	#print "$file\n";

	my $deps=$incdepends{$file};
	if (defined($deps)) {
		return $deps;
	}
	my $incdirs=shift;
	my $fh=$file;

	my @deps=();

	open($fh, "<$file") || die "cannot open $file";
	while(<$fh>) {
		if (/^\s*#include\s*<\s*([^" \t]+)\s*>/) {
			push(@deps, $1);
			next;
		}
		next unless (/^\s*#include\s*"\s*([^" \t]+)\s*"/);
		my $h=$1;
		#print "header: $h\n";
		my $cand="";
		foreach my $dir (@{$incdirs}) {
			$dir .= "\\" unless ( $dir =~ /\\$/ );
			$cand = $dir . $h;
			#print "$cand\n";
			if (-f $cand) {
				last;
			}
			$cand="";
		}
		unless ($cand eq "") {
			push(@deps, $cand);
			my $low_deps=incdepends($cand, $incdirs);
			push(@deps, @{$low_deps});
		}
	}
	close($fh);
	@deps=sort { $a cmp $b } @deps;
	$incdepends{$file}=\@deps;
	return \@deps;
}

sub depchanged($$$) {
	my $mmp=shift;
	print "checking dependancies in $mmp...";
	my $sourcefiles=shift;
	my $includedirs=shift;

	my $depstring="";

	foreach my $source (sort @{$sourcefiles}) {
		$depstring .= $source . ":";
		my $deps=incdepends($source, $includedirs);
		foreach my $d (@{$deps}) {
			$depstring .= " " . $d;
		}
	}

	my $depfile=$ENV{'EPOCROOT'};
	$depfile=~s/.*\\([^\\]*)\\$/$1/;
	mkdir $depfile, 0777;
	$mmp=~s/\./_/g;
	$mmp .= ".dep";
	$depfile .= "\\" . $mmp;
	my $ret=1;
	if (-f $depfile ) {
		my $olddepstring="";
		open(DEP, "<$depfile") || die "cannot open $depfile";
		while(<DEP>) {
			$olddepstring .= $_;
		}
		close(DEP);
		if ($olddepstring eq $depstring) {
			$ret=0;
		}
	}
	open(DEP, ">$depfile") || die "cannot open $depfile";
	print DEP $depstring;
	close(DEP);
	if ($ret) { print " changed."; }
	else { print " no changes."; }
	print "\n";
	return $ret;
}

open(BLDINF, "<bld.inf") || die "cannot open bld.inf";
while(<BLDINF>) {
	next if (m!^//!);
	next unless (/mmp$/i);
	
	chop; s/
//;
	my $mmp=$_;
	$|=1;

	/^(.*)\\([^\\]*).mmp$/i;
	my ($path, $file)=($1, $2);
	my ($depends, $type, $has_resource, $sourcefiles, $dummy, $includedirs, $dummy2)=
		getdepends(mmp($file), mmp($file), "", 0);

	$?=0;
	my $mmpchanged=haschanged($file, $depends);
	if ($mmpchanged) { print "MMP file (or file included from MMP) changed\n"; }
	my $dependschanged=depchanged($file, $sourcefiles, $includedirs);
	if ( lc($type) eq dll ) {
		make_sure_deffile_exists($file);
	}
	if ($?==0 && ($mmpchanged || $dependschanged) ) { 
		system("perl ..\\run_abld.pl makefile $platform $file");
	}
	if ($?==0 && 0 && $has_resource) {
		# this doesn't seem to be necessary? gets created with 'target'
		system("perl ..\\run_abld.pl resource $platform $release $file");
	}

	if ($? ==0 ) { system("perl ..\\run_abld.pl target $platform $release $file $type"); }
	if ($? == -1) {
		print "failed to execute: $!\n";
		exit 1;
	} else {
		my $ret= $? >> 8;
		if ($ret != 0) {
			printf "child exited with value %d\n", $ret;
			exit $ret;
		}
	}
}

close(BLDINF);

exit 0;
